/*
 * @Author       : ChenJie
 * @Date         : 2021-10-14 09:27:15
 * @LastEditors  : ChenJie
 * @LastEditTime : 2021-11-12 16:11:45
 * @Description  : Global variable definition H file
 * @FilePath     : \PLAT\project\ec616_0h00\apps\qx_app\inc\AppSignal.h
 */
#include "commontypedef.h"
#include "cmsis_os2.h"
#include "AppConfig.h"
#include "osasys.h"
#include "queue.h"
#include "bsp_custom.h"
#include "lwip_config_ec6160h00.h"
#include "BCUDisp.h"
//declear the bool vars
extern volatile BOOL NB_Fota_update_flag;
extern volatile BOOL BMS_Fota_update_flag;
extern UINT32 ErrFlg;

extern BOOL downloadReady;

//extern declear the UINT8 vars
extern UINT8 AvgBattTemp;
extern UINT8 battCellTemp[8];
extern UINT8 battHeatEnableState;
extern UINT8 battMOSSwitchState;
extern UINT8 battSOC;
extern UINT8 battSOH;
extern UINT8 battWorkState;
extern UINT8 BattWorkStateDelay;
extern UINT8 bmsHwVersion;
extern UINT8 bmsSwVersion;
extern UINT8 BMSupdatestatus;
extern UINT8 BuzzerControl;
extern UINT8 CanMsgEnble;
extern UINT8 ChargeForbiddenControl;
extern UINT8 chargerConnectState;
extern UINT8 DisChargeForbiddenControl;
extern UINT8 fastChargeTemp;
extern UINT8 GpsFlag;
extern UINT8 HeatForceControl;
extern UINT8 heatTemp1;
extern UINT8 heatTemp2;
extern UINT8 Lockstatus;
extern UINT8 maxCellTemp;
extern UINT8 minCellTemp;
extern UINT8 MOSTemp;
extern UINT8 nbReservedTemp1;
extern UINT8 nbReservedTemp2;
extern UINT8 normalChargeTemp;
extern UINT8 packTemp;
extern UINT8 PadInterrupt;
extern UINT8 PosFlag;
extern UINT8 RelayForbiddenControl;
extern UINT8 RelayForceControl;
extern UINT8 reservedSignal1;
extern UINT8 reservedSignal2;
extern UINT8 reservedSignal3;
extern UINT8 reservedSignal4;
extern UINT8 reservedSignal5;
extern UINT8 reservedSignal6;
extern UINT8 reservedSignal7;
extern UINT8 reservedSignal8;
extern UINT8 TcpErrorcount;
extern UINT8 TcpSendLen;
extern UINT8 TCPWorkState;
extern UINT8 UartCmdRecvFlag;
extern UINT8 UartErrorFlag;
extern UINT8 UartInterruptcount;
extern UINT8 UartRecvFlag;
extern UINT8 UDSService[2];              //uds 服务
extern UINT8 UDSSubService[2];           // uds 子服务
extern UINT8 UDSSubServiceActionCode[2]; // uds 子服务状态
extern UINT8 UDSSwitch;
extern UINT8 UDSDialogMode;
//declear the UINT16 vars
extern UINT16 battCellU[28];
extern UINT16 battI;
extern UINT16 battPackVol;
extern UINT16 maxCellVol;
extern UINT16 minCellVol;
extern UINT16 nbHwVersion;
extern UINT16 avrgCellVol;
extern UINT16 ErrorNum[ErrorNumLength];
extern UINT16 updateDifferDataPackageCounter;
extern INT16 xyzData[3];
extern UINT8 otherTempAvg;
//declear the UINT32 vars
extern UINT32 battBalanceoInfo;
extern UINT32 battProtectState;
extern UINT32 battWarningState;
extern UINT32 nbSwVersion;
extern UINT32 Battdesigncap;
extern UINT32 PowerVoltage;
extern volatile UINT32 TimeCounter;

//declear other vars
extern AppAlgorithmData BcuDataInfo;
extern AppConfigDataType AppNVMData;
extern AppDataBody AppDataInfo;
extern AppSocketConnectionContext socContext; //网络连接状态
extern osMutexId_t Error_Mutex;
extern process_app gProcess_app;
extern QueueHandle_t GpsRecvHandle;
extern QueueHandle_t UartWriteCmdHandle;
