/****************************************************************************
 *
 * Copy right:   Qx.Chen jie
 * File name:    AppTaskGps.h
 * Description:  Gps处理任务和三轴数据处理及获取
 * History:      2021-03-07 2021-07-15
 * Version:      V3.0
 ****************************************************************************/
//
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "AppFunc.h"
#include "AppSignal.h"
#include "AppConfig.h"
#include "hal_module_adapter.h"

#define GPS_TASK_STACK_SIZE   								 (512)
typedef enum
{
    PROCESS_GPS_STATE_INIT = 0,
    PROCESS_GPS_STATE_IDLE,
    PROCESS_GPS_STATE_WORK,
    PROCESS_GPS_STATE_SLEEP
}process_gps;

void AppTaskGpsInit(void *arg);
void AppTaskGpsDeInit(void *arg);