/****************************************************************************
 *
 * Copy right:   Qx.
 * File name:    MainTask.h
 * Description:  APP任务调取和异常处理
 * History:      2021-03-05
 *
 ****************************************************************************/
#include "commontypedef.h"
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "hal_module_adapter.h"
#include "timers.h"
#include "AppSignal.h"
#include "AppFunc.h"
#define PROC_MAIN_TASK_STACK_SIZE           (1024+512)

typedef enum
{
    PROCESS_STATE_IDLE = 0,
    PROCESS_STATE_WORK,
    PROCESS_STATE_LISTEN
}process_Main;

void AppTaskMainInit(void* arg);
void AppTaskMainDeInit(void* arg);

