#include "SPM.h"

boolean_T FirstRun_SPM;

void SPM_Init(void)
{
  SOH_Init();
  BLC_Init();
  CDM_Init();
  SOC_Init();
  PIM_Init();
  SOE_Init();
  SOR_Init();
  FirstRun_SPM = true;
}

void SPM(void)
{
  static uint16_T spmd_Nr_cellNr;
  uint8_T Feq = 30;
  if (FirstRun_SPM)
  {
    spmd_Nr_cellNr = 0;
    cand_Nr_cellNr = 1;
  }
  spmd_Nr_cellNr = spmd_Nr_cellNr + 1;
  if (spmd_Nr_cellNr % Feq == 0)
  {
    cand_Nr_cellNr ++;
  }
  else if (spmd_Nr_cellNr > 60000)
  {
    spmd_Nr_cellNr = 0;
  }
  if (cand_Nr_cellNr > cmnc_num_cellUNum)
  {
    cand_Nr_cellNr = 1;
  }
  //调用SOX算法
  SOH();
  BLC();
  if (ihd_flg_urtRecFlg && sfmd_V_cellUMin != 0)
  {
      CDM();
	  SOC();
	  PIM();
	  SOE();
	  SOR();
  }
  // 循环发送数组
  cand_Q_cellCap = sohv_Q_cellCapArrEo[cand_Nr_cellNr-1];
  cand_V_chrgStartStat = sohv_V_chrgStartStatEo[cand_Nr_cellNr-1];
  cand_Q_reqCp   = blcv_Q_reqCpEo[cand_Nr_cellNr-1];
  cand_Q_totalCp = blcv_Q_totalCpEo[cand_Nr_cellNr-1];
  FirstRun_SPM = false;
}


