/****************************************************************************
 *
 * Copy right:   2021-, Copyrigths of RLWL Ltd.Zhen C
 * File name:    AppTaskCan.h
 * Description:  App Task Can H file 
 * History:      Rev3.0   2021-07-06
 *
 ****************************************************************************/
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "hal_module_adapter.h"
#include "app.h"
#include "AppSignal.h"
#include "AppFunc.h"
#include "AppConfig.h"

#define 			PROC_CAN_RX_TASK_STACK_SIZE			(1024)
typedef enum
{
    PROCESS_CAN_STATE_INIT = 0,
    PROCESS_CAN_STATE_IDLE,
    PROCESS_CAN_STATE_WORK,
    PROCESS_CAN_STATE_SLEEP
}process_CAN;

void AppTaskCanInit(void* arg);
static void Can_Receive(void);



