/****************************************************************************
 *
 * Copy right:   Qx.Chen Jie
 * File name:    AppTaskControl.h
 * Description:  LED控制和蜂鸣器控制和继电器控制逻辑判定
 * History:      2021-07-05
 * Version:      V3.0
 ****************************************************************************/
#include "commontypedef.h"
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "hal_module_adapter.h"
#include "timers.h"
#include "AppFunc.h"
#include "AppSignal.h"
#include "AppConfig.h"
#include "hal_module_adapter.h"
#define PROC_CONTROL_TASK_STACK_SIZE           (1024)
typedef enum
{
    PROCESS_CONTROL_STATE_IDLE = 0,
    PROCESS_CONTROL_STATE_WORK,
    PROCESS_CONTROL_STATE_SLEEP
}process_control;
void AppTaskControlInit(void *arg);
void AppTaskControlDeInit(void *arg);
