/****************************************************************************
 *
 * Copy right:   2021-, Copyrigths of RLWL Ltd. Chen J
 * File name:    app.h
 * Description:  App definition H file
 * History:      Rev3.0   2021-07-06
 *
 ****************************************************************************/
#include "commontypedef.h"
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"
#include "ec_tcpip_api.h"
#include "hal_module_adapter.h"
#include "timers.h"
#include "BCU.h"
#ifndef  APP_H
#define  APP_H
#ifdef __cplusplus
extern "C" {
#endif
extern void AppTaskMainInit(void* arg);
extern void AppTaskTcpInit(void *arg);
extern void AppTaskControlInit(void *arg);
extern void AppTaskGpsInit(void *arg);
extern void AppTaskUartInit(void *arg);
extern void AppTaskCanInit(void *arg);
#ifdef __cplusplus
}
#endif
#endif /* APP_H */
