/****************************************************************************
 *
 * Copy right:   2021-, Copyrigths of RLWL Ltd.Chen J
 * File name:    app.c
 * Description:  App definition c file,主要负责内核启动以及各线程启动
 * History:      Rev3.0   2021-07-06
 *
 ****************************************************************************/
#include "app.h"
void appInit(void *arg)
{
    AppTaskMainInit(arg);
    AppTaskTcpInit(arg);
    AppTaskControlInit(arg);
    AdcTaskInit();
    AppTaskGpsInit(arg);
    AppTaskUartInit(arg);
    AppTaskCanInit(arg);
    AppTaskBcuInit(arg);
}
void main_entry(void) 
{
    BSP_CommonInit();
    osKernelInitialize();
    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}
